<?php
	$secret = '';  // WLAN API Key, obtained from the Mist Web GUI after creating the WLAN
	$wlan_id = $_POST['wlan_id'];
	$ap_mac = $_POST['ap_mac'];
	$client_mac = $_POST['client_mac'];
	$url = $_POST['url'];
	$ap_name = $_POST['ap_name'];
	$site_name = $_POST['site_name'];

	$authorize_min = 525600;  // Duration (in minutes) the guest MAC address is authorized before they are redirected back to the portal page
	$download_kbps = 0;  // Download limit (in kbps) per client. Recommended to leave as 0 (unlimited), as this can be set globally in the WLAN
	$upload_kbps = 0;  // Upload limit (in kbps) per client. Recommended to leave as 0 (unlimited), as this can be set globally in the WLAN
	$quota_mbytes = 0;  // Quota (in mbytes) per client. Recommended to leave as 0 (unlimited)
	$context = sprintf('%s/%s/%s/%d/%d/%d/%d',
		$wlan_id, $ap_mac, $client_mac,
		$authorize_min,
		$download_kbps, $upload_kbps, $quota_mbytes
	);
	$token = urlencode(base64_encode($context));

	// The below portal fields are passed back to Mist and shown in the Guest Portal Information
	$name = $_POST['name'];
	$email = $_POST['email'];
	$field1 = 'Whatever you want Custom field 1 to be';
	$field2 = 'Whatever you want Custom field 2 to be';
	$field3 = 'Whatever you want Custom field 3 to be';
	$field4 = 'Whatever you want Custom field 4 to be';

	$forward = urlencode($url);  // URL the user is forwarded to after authorization
	$extra = '&forward=' . $forward;
	$extra .= '&name=' . urlencode("$name");
	$extra .= '&field1=' . urlencode("$field1");
	$extra .= '&field2=' . urlencode("$field2");
	$extra .= '&field3=' . urlencode("$field3");
	$extra .= '&field4=' . urlencode("$field4");
	$extra .= '&email=' . urlencode("$email");
	$expires = time() + 120;  // The time until which the authorization URL is valid
	$payload = sprintf('expires=%d&token=%s%s', $expires, $token, $extra);

	$signature = urlencode(base64_encode(hash_hmac('sha1', $payload, $secret, true)));
	$final_url = sprintf('http://portal.mist.com/authorize?signature=%s&%s', $signature, $payload);

	/*
	  Debug code used for testing purposes only
	  If set to true, display the variable details without authorizing the guest in the Mist cloud
	*/
	$debugging = false;
	if ($debugging) {
		header('Content-Type: text/plain');
		echo sprintf('token          : urlencode(base64(%s))', $context) . PHP_EOL;
		echo sprintf('                 %s', $token) . PHP_EOL;
		echo sprintf('foward         : %s', $url) . PHP_EOL;
		echo sprintf('                 %s', $foward) . PHP_EOL;
		echo sprintf('payload-to-sign: %s', $payload) . PHP_EOL;
		echo sprintf('signature      : %s', $signature) . PHP_EOL;
		echo sprintf('URL            : %s', $final_url) . PHP_EOL;
		echo sprintf('client_mac     : %s', $client_mac) . PHP_EOL;
		echo sprintf('ap_mac         : %s', $ap_mac) . PHP_EOL;
		echo sprintf('ap_name        : %s', $ap_name) . PHP_EOL;
		echo sprintf('wlan_id        : %s', $wlan_id) . PHP_EOL;
		echo sprintf('site_name      : %s', $site_name) . PHP_EOL;
		echo sprintf('name           : %s', $name) . PHP_EOL;
		echo sprintf('email          : %s', $email) . PHP_EOL;
		echo sprintf('field1         : %s', $field1) . PHP_EOL;
		echo sprintf('field2         : %s', $field2) . PHP_EOL;
		echo sprintf('field3         : %s', $field3) . PHP_EOL;
		echo sprintf('field4         : %s', $field4) . PHP_EOL;
	}
	else {
		// Guest is redirected to the Mist portal for authorization. If successful, the Mist portal will then redirect the guest to the $url 
		header('Location: ' . $final_url);
	}
?>